## exhale-dmo 1.2.0

=== CMakeLists.txt ===
## CMakeLists.txt - Main CMake file that defines how cmake should process and generate the necessary build files
 # written by C. D. Degawa, last modified in 2022 - see License.htm for legal notices
 #
 # The copyright in this software is being made available under the exhale Copyright License
 # and comes with ABSOLUTELY NO WARRANTY. This software may be subject to other third-
 # party rights, including patent rights. No such rights are granted under this License.
 #
 # Copyright (c) 2018-2021 Christian R. Helmrich, project ecodis. All rights reserved.
 ##

cmake_minimum_required(VERSION 3.5) # Default version of cmake on Ubuntu 16.04

if("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
    message(FATAL_ERROR "Building in the source tree is not supported.\n"
                        "Please re-run cmake from a build folder.")
endif()


project(exhale VERSION 1.2.0 LANGUAGES CXX)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_BUILD_TYPE Release
        CACHE
        STRING "Build type: Debug, Release, RelWithDebInfo or MinSizeRel"
        FORCE)
endif()

set(CMAKE_THREAD_PREFER_PTHREAD true)
find_package(Threads) # For Threads::Threads
include(GNUInstallDirs)

set(CMAKE_POSITION_INDEPENDENT_CODE true)
set(CXX_STANDARD 11)
if(MSVC)
    set(CMAKE_CXX_FLAGS_DEBUG "/WX /D_DEBUG ${CMAKE_CXX_FLAGS_DEBUG}")
else()
    set(CMAKE_CXX_FLAGS "-Wall -Wshadow ${CMAKE_CXX_FLAGS}")
    if(WIN32 AND MINGW)
        set(CMAKE_CXX_FLAGS "-municode ${CMAKE_CXX_FLAGS}")
    endif()
    set(CMAKE_CXX_FLAGS_RELEASE "-Wuninitialized ${CMAKE_CXX_FLAGS_RELEASE}")
    set(CMAKE_CXX_FLAGS_DEBUG "-Werror -D_DEBUG ${CMAKE_CXX_FLAGS_DEBUG}")
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    add_definitions(-D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64)
endif()


add_subdirectory(src/lib)
add_subdirectory(src/app)

=== src/lib/CMakeLists.txt ===
## CMakeLists.txt - CMake file that defines the build for the lib folder, works in conjunction with the main CMakeLists.txt
 # written by C. D. Degawa, last modified in 2020 - see License.htm for legal notices
 #
 # The copyright in this software is being made available under the exhale Copyright License
 # and comes with ABSOLUTELY NO WARRANTY. This software may be subject to other third-
 # party rights, including patent rights. No such rights are granted under this License.
 #
 # Copyright (c) 2018-2021 Christian R. Helmrich, project ecodis. All rights reserved.
 ##

add_library(exhaleLib
    lappedTransform.cpp
    exhaleLibPch.cpp
    bitStreamWriter.cpp
    quantization.cpp
    stereoProcessing.h
    exhaleLibPch.h
    entropyCoding.cpp
    tempAnalysis.cpp
    bitAllocation.cpp
    stereoProcessing.cpp
    bitAllocation.h
    bitStreamWriter.h
    specAnalysis.h
    specAnalysis.cpp
    lappedTransform.h
    specGapFilling.cpp
    specGapFilling.h
    linearPrediction.h
    quantization.h
    entropyCoding.h
    exhaleEnc.cpp
    tempAnalysis.h
    linearPrediction.cpp
    exhaleEnc.h
    ${PROJECT_SOURCE_DIR}/include/exhaleDecl.h
    ${PROJECT_SOURCE_DIR}/include/version.h)

set_target_properties(exhaleLib PROPERTIES OUTPUT_NAME exhale)

if(TARGET Threads::Threads)
    target_link_libraries(exhaleLib PRIVATE Threads::Threads)
endif()
if(CMAKE_DL_LIBS)
    target_link_libraries(exhaleLib PRIVATE ${CMAKE_DL_LIBS})
endif()
target_include_directories(exhaleLib PRIVATE ${PROJECT_SOURCE_DIR}/include)
set_target_properties(exhaleLib PROPERTIES PUBLIC_HEADER "${PROJECT_SOURCE_DIR}/include/exhaleDecl.h")

# PCH requires at least 3.16
# I actually don't know if this works or not
if(CMAKE_VERSION VERSION_GREATER "3.16.0")
    target_precompile_headers(exhaleLib PUBLIC ${PROJECT_SOURCE_DIR}/src/lib/exhaleLibPch.h)
endif()

target_compile_definitions(exhaleLib PRIVATE EXHALE_DYN_LINK)

install(TARGETS exhaleLib
    ARCHIVE DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_FULL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_FULL_INCLUDEDIR})

=== debian/changelog ===
exhale-dmo (1.2.0-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 07 Apr 2023 16:11:53 +0200

=== debian/control ===
Source: exhale-dmo
Section: sound
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: http://www.ecodis.de/audio.htm
Rules-Requires-Root: no
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13), cmake, html2text

Package: exhale
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
Description: extended high-efficiency and low-complexity encoder.
 exhale, which is an acronym for "Ecodis eXtended High-efficiency And
 Low-complexity Encoder", is a lightweight library and application to encode
 uncompressed WAVE-format audio files into MPEG-4-format files complying with
 the ISO/IEC 23003-3 (MPEG-D) Unified Speech and Audio Coding (USAC, also
 known as Extended High-Efficiency AAC) standard.
 .
 In addition, exhale writes program peak-level and loudness data into the
 generated MPEG-4 files according to the ISO/IEC 23003-4, Dynamic Range
 Control (DRC) specification for use by decoders providing DRC.
 .
 exhale currently makes use of all frequency-domain (FD) coding tools in the
 scalefactor based MDCT processing path. Its objective is high quality mono,
 stereo, and multichannel coding at medium and high bit rates, so the
 lower-rate USAC coding tools (ACELP, TCX, Enhanced SBR and MPEG Surround
 with Unified Stereo coding) won't be integrated.
 .
 Important: Due to the missing lower-rate coding tools, the audio quality at
 the lowest of exhale's bit-rate modes (18 kbit/s mono, 36 kbit/s stereo)
 doesn't reflect the full capabilities of the Extended HE-AAC standard. 
 Therefore, use the lowest bit-rate modes only when required. Also, please
 don't attempt to modify exhale's source code or to configure the
 command-line encoder to produce lower bit-rates. Use only existing presets
 and input sampling rates of 32...48 kHz.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	$(MAKE) -C src/lib  debug UNIVERSAL2=$(UNIVERSAL2)
	$(MAKE) -C src/app  debug UNIVERSAL2=$(UNIVERSAL2)

override_dh_auto_install:
	dh_install bin/exhaled usr/bin

	mv debian/exhale/usr/bin/exhaled debian/exhale/usr/bin/exhale

override_dh_installchangelogs:
	html2text include/Release.htm > debian/upstream-changelog.txt

	dh_installchangelogs debian/upstream-changelog.txt

=== debian/watch ===
version=4

https://gitlab.com/ecodis/exhale/-/tags \
/ecodis/exhale/-/archive/v?@ANY_VERSION@/exhale-v?\d\S*@ARCHIVE_EXT@

## exhale-dmo 1.2.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
 ## CMakeLists.txt - Main CMake file that defines how cmake should process and generate the necessary build files
- # written by C. D. Degawa, last modified in 2022 - see License.htm for legal notices
+ # written by C. D. Degawa, last modified in 2023 - see License.htm for legal notices
  #
  # The copyright in this software is being made available under the exhale Copyright License
  # and comes with ABSOLUTELY NO WARRANTY. This software may be subject to other third-
  # party rights, including patent rights. No such rights are granted under this License.
  #
- # Copyright (c) 2018-2021 Christian R. Helmrich, project ecodis. All rights reserved.
+ # Copyright (c) 2018-2024 Christian R. Helmrich, project ecodis. All rights reserved.
  ##
 
 cmake_minimum_required(VERSION 3.5) # Default version of cmake on Ubuntu 16.04
@@ -16,7 +16,7 @@
 endif()
 
 
-project(exhale VERSION 1.2.0 LANGUAGES CXX)
+project(exhale VERSION 1.2.1 LANGUAGES CXX)
 
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
     set(CMAKE_BUILD_TYPE Release

=== debian/changelog ===
exhale-dmo (1.2.1.2-dmo2) unstable; urgency=medium

  * Don't use cmake to buildthe package this doesn't work.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 10 May 2025 13:17:05 +0200

exhale-dmo (1.2.1.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 10 May 2025 12:09:56 +0200

exhale-dmo (1.2.1-dmo1+b1) unstable; urgency=medium

  * Rebuild for PAC/BTI support; no source changes.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 02 Nov 2024 18:03:28 +0100

exhale-dmo (1.2.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 24 Dec 2023 00:01:13 +0100

exhale-dmo (1.2.0.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 01 Aug 2023 08:38:20 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,10 @@
 #!/usr/bin/make -f
+
+ifeq ($(origin CPP),default)
+	CPP := $(DEB_HOST_GNU_TYPE)-g++
+endif
+
+export CPP
 
 %:
 	dh $@
@@ -16,3 +22,5 @@
 	html2text include/Release.htm > debian/upstream-changelog.txt
 
 	dh_installchangelogs debian/upstream-changelog.txt
+
+override_dh_auto_test:

=== debian/watch ===
version=4

https://gitlab.com/ecodis/exhale/-/tags \
/ecodis/exhale/-/tags/@ANY_VERSION@

## exhale-dmo 1.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
 ## CMakeLists.txt - Main CMake file that defines how cmake should process and generate the necessary build files
- # written by C. D. Degawa, last modified in 2023 - see License.htm for legal notices
+ # written by C. D. Degawa, last modified in 2025 - see License.htm for legal notices
  #
  # The copyright in this software is being made available under the exhale Copyright License
  # and comes with ABSOLUTELY NO WARRANTY. This software may be subject to other third-
  # party rights, including patent rights. No such rights are granted under this License.
  #
- # Copyright (c) 2018-2024 Christian R. Helmrich, project ecodis. All rights reserved.
+ # Copyright (c) 2018-2025 Christian R. Helmrich, project ecodis. All rights reserved.
  ##
 
 cmake_minimum_required(VERSION 3.5) # Default version of cmake on Ubuntu 16.04
@@ -16,7 +16,7 @@
 endif()
 
 
-project(exhale VERSION 1.2.1 LANGUAGES CXX)
+project(exhale VERSION 1.2.2 LANGUAGES CXX)
 
 if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
     set(CMAKE_BUILD_TYPE Release

=== src/app/CMakeLists.txt ===
## CMakeLists.txt - CMake file that defines the build for the app folder, works in conjunction with the main CMakeLists.txt
 # written by C. D. Degawa, last modified in 2020 - see License.htm for legal notices
 #
 # The copyright in this software is being made available under the exhale Copyright License
 # and comes with ABSOLUTELY NO WARRANTY. This software may be subject to other third-
 # party rights, including patent rights. No such rights are granted under this License.
 #
 # Copyright (c) 2018-2021 Christian R. Helmrich, project ecodis. All rights reserved.
 ##

add_executable(exhaleApp
    exhaleAppPch.h
    loudnessEstim.cpp
    basicMP4Writer.cpp
    basicMP4Writer.h
    exhaleApp.cpp
    loudnessEstim.h
    exhaleApp.ico
    exhaleApp.rc
    basicWavReader.h
    basicWavReader.cpp
    exhaleAppPch.cpp
    ${PROJECT_SOURCE_DIR}/include/exhaleDecl.h
    ${PROJECT_SOURCE_DIR}/include/version.h)

set_target_properties(exhaleApp PROPERTIES OUTPUT_NAME exhale)

if(TARGET Threads::Threads)
    target_link_libraries(exhaleApp PRIVATE Threads::Threads)
endif()
if(CMAKE_DL_LIBS)
    target_link_libraries(exhaleApp PRIVATE ${CMAKE_DL_LIBS})
endif()
target_link_libraries(exhaleApp PRIVATE exhaleLib)
target_include_directories(exhaleApp PRIVATE ${PROJECT_SOURCE_DIR}/include)
if(BUILD_SHARED_LIBS)
    target_compile_definitions(exhaleApp PRIVATE USE_EXHALELIB_DLL)
endif(BUILD_SHARED_LIBS)

# PCH requires at least 3.16
# I actually don't know if this works or not
if(CMAKE_VERSION VERSION_GREATER "3.16.0")
    target_precompile_headers(exhaleApp PUBLIC ${PROJECT_SOURCE_DIR}/src/lib/exhaleLibPch.h)
endif()

install(TARGETS exhaleApp
    RUNTIME DESTINATION ${CMAKE_INSTALL_FULL_BINDIR})

=== debian/changelog ===
exhale-dmo (1.2.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 20 Dec 2025 15:09:00 +0100

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,13 @@
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: http://www.ecodis.de/audio.htm
-Rules-Requires-Root: no
-Standards-Version: 4.6.2
-Build-Depends: debhelper-compat (= 13), cmake, html2text
+Standards-Version: 4.7.2
+Build-Depends: debhelper-compat (= 13), html2text,
 
 Package: exhale
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends},
-Description: extended high-efficiency and low-complexity encoder.
+Description: extended high-efficiency and low-complexity AAC encoder.
  exhale, which is an acronym for "Ecodis eXtended High-efficiency And
  Low-complexity Encoder", is a lightweight library and application to encode
  uncompressed WAVE-format audio files into MPEG-4-format files complying with

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,7 @@
 %:
 	dh $@
 
+# Doesn't build with cmake
 override_dh_auto_build:
 	$(MAKE) -C src/lib  debug UNIVERSAL2=$(UNIVERSAL2)
 	$(MAKE) -C src/app  debug UNIVERSAL2=$(UNIVERSAL2)

=== debian/watch ===
Version: 5

Template: GitLab
Dist: https://gitlab.com/ecodis/exhale/
